BorderedTextBox = class(Turbine.UI.Lotro.TextBox);

local Constants =
{
	BorderColour = Turbine.UI.Color(1.0, 0.16, 0.19, 0.24)
}

function BorderedTextBox:Constructor()
	Turbine.UI.Lotro.TextBox.Constructor(self);
	
	local createBorder = function(left, top, width, height)
		local border = Turbine.UI.Control();
		border:SetParent(self);
		border:SetPosition(left, top);
		border:SetSize(width, height);
		border:SetBackColor(Constants.BorderColour);
		border:SetZOrder(999);
		
		return border;
	end
	
	self.BorderTop = createBorder(0, 0, self:GetWidth() - 1, 1);
	self.BorderRight = createBorder(self:GetWidth() - 1, 0, 1, self:GetHeight());
	self.BorderBottom = createBorder(0, self:GetHeight() - 1, self:GetWidth(), 1);
	self.BorderLeft = createBorder(0, 0, 1, self:GetHeight());
	
	self.SizeChanged = function(sender, args)
		sender.BorderTop:SetSize(sender:GetWidth(), 1);
		
		sender.BorderLeft:SetSize(1, sender:GetHeight());
		
		sender.BorderBottom:SetPosition(0, sender:GetHeight() - 1);
		sender.BorderBottom:SetSize(sender:GetWidth() - 1, 1);
		
		sender.BorderRight:SetSize(1, sender:GetHeight());
		sender.BorderRight:SetPosition(sender:GetWidth() - 1, 0);
	end
end

function BorderedTextBox:SetSize(width, height)
	Turbine.UI.Window.SetSize(self, width, height);
	self:SizeChanged(self, nil);
end

function BorderedTextBox:SetWidth(width)
	Turbine.UI.Window.SetWidth(self, width);
	self:SizeChanged(self, nil);
end

function BorderedTextBox:SetHeight(height)
	Turbine.UI.Window.SetHeight(self, height);
	self:SizeChanged(self, nil);
end

function BorderedTextBox:SetBorderColour(colour)
	self.BorderTop:SetBackColor(colour);
	self.BorderRight:SetBackColor(colour);
	self.BorderBottom:SetBackColor(colour);
	self.BorderLeft:SetBackColor(colour);
end